/* GCC */
#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>

using namespace std;

const int MAX=2e2+2;

int n;

void turn_row(int arr[MAX][MAX], int x)
{
    for(int j=1; j<=n; ++j)
        swap(arr[x][j], arr[x][2*n-j+1]);
}

void turn_column(int arr[MAX][MAX], int y)
{
    for(int i=1; i<=n; ++i)
        swap(arr[i][y], arr[2*n-i+1][y]);
}

bool existance;
int in[MAX][MAX];
int arr[MAX][MAX];
bool brr[MAX][MAX];

int main()
{
    ios::sync_with_stdio(0);
    ifstream cin("square.in");
    ofstream cout("square.out");
int t; cin >> t; while(t--)
{
    existance=true;
    cin >> n;
    for(int i=1; i<=2*n; ++i)
        for(int j=1; j<=2*n; ++j)
            cin >> in[i][j], arr[i][j]=in[i][j];
    vector <int> smooth;
    smooth.push_back(in[1][1]);
    smooth.push_back(in[2*n][1]);
    smooth.push_back(in[2*n][2*n]);
    smooth.push_back(in[1][2*n]);
    sort(smooth.begin(), smooth.end());
    for(int i=1; i<=n; ++i)
    {
        for(int j=1; j<=n; ++j)
        {
            vector <int> tmp;
            tmp.push_back(in[i][j]);
            tmp.push_back(in[2*n-i+1][j]);
            tmp.push_back(in[2*n-i+1][2*n-j+1]);
            tmp.push_back(in[i][2*n-j+1]);
            sort(tmp.begin(), tmp.end());
            if(tmp!=smooth)
                existance=false;
        }
    }
    smooth.clear();
    smooth.push_back(in[1][1]);
    smooth.push_back(in[2*n][1]);
    smooth.push_back(in[2*n][2*n]);
    smooth.push_back(in[1][2*n]);
    for(int i=1; i<=n; ++i)
    {
        for(int j=1; j<=n; ++j)
        {
            if(smooth[0]==arr[i][2*n-j+1])
            {
                turn_row(arr, i);
                turn_column(arr, j);
                turn_row(arr, i);
                turn_column(arr, j);
            }
            else if(smooth[0]==arr[2*n-i+1][j])
            {
                turn_column(arr, j);
                turn_row(arr, i);
                turn_column(arr, j);
                turn_row(arr, i);
            }
            else if(smooth[0]==arr[2*n-i+1][2*n-j+1])
            {
                turn_column(arr, j);
                turn_row(arr, 2*n-i+1);
                turn_column(arr, j);
                turn_row(arr, 2*n-i+1);
            }
            if(smooth[3]==arr[2*n-i+1][j])
            {
                turn_column(arr, 2*n-j+1);
                turn_row(arr, 2*n-i+1);
                turn_column(arr, 2*n-j+1);
                turn_row(arr, 2*n-i+1);
            }
            else if(smooth[3]==arr[2*n-i+1][2*n-j+1])
            {
                turn_row(arr, 2*n-i+1);
                turn_column(arr, 2*n-j+1);
                turn_row(arr, 2*n-i+1);
                turn_column(arr, 2*n-j+1);
            }
            brr[i][j]=(smooth[1]!=arr[2*n-i+1][j]);
        }
    }
    vector < pair <char, int> > ans;
    for(int i=1; i<=n; ++i)
    {
        if(brr[i][1])
        {
            ans.push_back(make_pair('+', i));
            for(int j=1; j<=n; ++j)
                brr[i][j]=!brr[i][j];
            turn_row(in, i);
        }
    }
    for(int j=1; j<=n; ++j)
    {
        if(brr[1][j])
        {
            ans.push_back(make_pair('-', j));
            for(int i=1; i<=n; ++i)
                brr[i][j]=!brr[i][j];
            turn_column(in, j);
        }
    }
    for(int i=1; i<=n; ++i)
        for(int j=1; j<=n; ++j)
        {
            if(brr[i][j])
                existance=false;
            brr[i][j]=false;
        }
    if(existance)
    {
        vector <int> strong;
        strong.push_back(in[1][1]);
        strong.push_back(in[2*n][1]);
        strong.push_back(in[2*n][2*n]);
        strong.push_back(in[1][2*n]);
        for(int i=1; i<=n; ++i)
        {
            for(int j=1; j<=n; ++j)
            {
                if(strong[0]==in[i][2*n-j+1])
                {
                    turn_row(in, i);
                    ans.push_back(make_pair('+', i));
                    turn_column(in, j);
                    ans.push_back(make_pair('-', j));
                    turn_row(in, i);
                    ans.push_back(make_pair('+', i));
                    turn_column(in, j);
                    ans.push_back(make_pair('-', j));
                }
                else if(strong[0]==in[2*n-i+1][j])
                {
                    turn_column(in, j);
                    ans.push_back(make_pair('-', j));
                    turn_row(in, i);
                    ans.push_back(make_pair('+', i));
                    turn_column(in, j);
                    ans.push_back(make_pair('-', j));
                    turn_row(in, i);
                    ans.push_back(make_pair('+', i));
                }
                else if(strong[0]==in[2*n-i+1][2*n-j+1])
                {
                    turn_column(in, j);
                    ans.push_back(make_pair('-', j));
                    turn_row(in, 2*n-i+1);
                    ans.push_back(make_pair('+', 2*n-i+1));
                    turn_column(in, j);
                    ans.push_back(make_pair('-', j));
                    turn_row(in, 2*n-i+1);
                    ans.push_back(make_pair('+', 2*n-i+1));
                }
                if(strong[3]==in[2*n-i+1][j])
                {
                    turn_column(in, 2*n-j+1);
                    ans.push_back(make_pair('-', 2*n-j+1));
                    turn_row(in, 2*n-i+1);
                    ans.push_back(make_pair('+', 2*n-i+1));
                    turn_column(in, 2*n-j+1);
                    ans.push_back(make_pair('-', 2*n-j+1));
                    turn_row(in, 2*n-i+1);
                    ans.push_back(make_pair('+', 2*n-i+1));
                }
                else if(strong[3]==in[2*n-i+1][2*n-j+1])
                {
                    turn_row(in, 2*n-i+1);
                    ans.push_back(make_pair('+', 2*n-i+1));
                    turn_column(in, 2*n-j+1);
                    ans.push_back(make_pair('-', 2*n-j+1));
                    turn_row(in, 2*n-i+1);
                    ans.push_back(make_pair('+', 2*n-i+1));
                    turn_column(in, 2*n-j+1);
                    ans.push_back(make_pair('-', 2*n-j+1));
                }
            }
        }
        cout << ans.size() << endl;
        for(int i=0; i<ans.size(); ++i)
            cout << ans[i].first << ans[i].second << endl;
    }
    else cout << "-1\n";
}
    return 0;
}
