/* GCC */
#include <cstdio>
#include <cmath>
#include <fstream>
#include <string>
#include <vector>
#include <map>
#include <set>

using namespace std;

struct point
{
    int x;
    int y;
};

point pts[250000];
int l[250000], r[250000], p[250000], root(0), ans_h, ans_l;
const long long base = 1000000000;
long long ans(0);

void dfs(int v)
{
    if(l[v] != -1)
    {
        (ans += abs(pts[v].x - pts[l[v]].x)) += abs(pts[v].y - pts[l[v]].y);
        dfs(l[v]);
    }
    if(r[v] != -1)
    {
        (ans += abs(pts[v].x - pts[r[v]].x)) += abs(pts[v].y - pts[r[v]].y);
        dfs(r[v]);
    }
}

int main(void)
{
	ios_base::sync_with_stdio(false);
	freopen("nests.in", "r", stdin);
	freopen("nests.out", "w", stdout);
	int n;
	scanf("%d", &n);
	for(int i = 0; i < n; ++i)
    {
        l[i] = r[i] = p[i] = -1;
        scanf("%d%d", &pts[i].x, &pts[i].y);
        if(i == 0)
            continue;
        if(pts[i].y > pts[root].y)
        {
            l[i] = root;
            p[root] = i;
            root = i;
            continue;
        }
        int j = i - 1;
        while(pts[j].y < pts[i].y)
            j = p[j];
        p[i] = j;
        l[i] = r[j];
        r[j] = i;
    }
    dfs(root);
    ans_h = ans / base, ans_l = ans - ans_h * base;
    if(ans_h == 0)
        printf("%d\n", ans_l);
    else
    {
        printf("%d", ans_h);
        int cnt_zero = 8;
        for(int i = 10; i <= ans_l; i *= 10, --cnt_zero);
        for(int i = 0; i < cnt_zero; ++i)
            putchar('0');
        printf("%d\n", ans_l);
    }
	return 0;
}
