/* GCC */
#include <cstdio>
#include <vector>
#include <map>
#include <algorithm>

using namespace std;
typedef unsigned short Elem;

inline Elem h(Elem a, Elem b, Elem c, Elem d)
{
    return 125*a + 25*b + 5*c + d;
}

inline Elem inv(Elem a)
{
    return a == 0 ? 1 : 0;
}

struct Move
{
    Move(char d, Elem n)
        : dir(d), num(n)
    {}
    char dir;
    Elem num;
};

int main(void)
{
    size_t t, n, n2, right, down;
    Elem msk[625] = {}, mask, tmp, need;
    msk[h(1, 2, 3, 4)] = msk[h(3, 1, 2, 4)] = msk[h(2, 3, 1, 4)] = msk[h(4, 1, 3, 2)] =
    msk[h(2, 4, 3, 1)] = msk[h(4, 2, 1, 3)] = msk[h(3, 2, 4, 1)] = msk[h(1, 4, 2, 3)] =
    msk[h(1, 3, 4, 2)] = msk[h(4, 3, 2, 1)] = msk[h(3, 4, 1, 2)] = msk[h(2, 1, 4, 3)] = 1;
    freopen("square.in", "r", stdin);
    freopen("square.out", "w", stdout);
    scanf("%u", &t);
    while(t--)
    {
        scanf("%u", &n);
        n2 = n << 1;
        bool bad = false;
        map<Elem, Elem> m;
        vector<vector<Elem> > v(n2, vector<Elem>(n2));
        for(size_t i = 0; i < n2; ++i)
            for(size_t j = 0; j < n2; ++j)
                scanf("%hu", &v[i][j]);
        for(size_t i = 0; i < n2 && !bad; ++i)
            for(size_t j = 0; j < n2; ++j)
                if(m[v[i][j]] == 0)
                {
                    m[v[i][j]] = m.size();
                    if(m.size() > 4)
                    {
                        bad = true;
                        break;
                    }
                }
        if(bad)
        {
            puts("-1");
            continue;
        }
        vector<vector<Elem> > hlp(n, vector<Elem>(n));
        for(size_t up = 0; up < n; ++up)
            for(size_t left = 0; left < n; ++left)
            {
                right = n2-1-left, down = n2-1-up;
                v[up][left] = m[v[up][left]];
                v[down][left] = m[v[down][left]];
                v[down][right] = m[v[down][right]];
                v[up][right] = m[v[up][right]];
                mask = h(v[up][left], v[up][right], v[down][left], v[down][right]);
                hlp[up][left] = msk[mask];
            }
        need = hlp[0][0];
        vector<Move> moves;
        for(size_t i = 1; i < n; ++i)
            if(hlp[i][0] != need)
            {
                for(size_t j = 0; j < n; ++j)
                {
                    hlp[i][j] = inv(hlp[i][j]);
                    swap(v[i][j], v[i][n2-1-j]);
                }
                moves.push_back(Move('+', i+1));
            }
        for(size_t j = 1; j < n; ++j)
        {
            for(size_t i = 1; i < n; ++i)
                if(hlp[i][j] != hlp[0][j])
                {
                    bad = true;
                    break;
                }
            if(bad)
                break;
            if(hlp[0][j] != need)
            {
                for(size_t i = 0; i < n; ++i)
                {
                    hlp[i][j] = need;
                    swap(v[i][j], v[n2-1-i][j]);
                }
                moves.push_back(Move('-', j+1));
            }
        }
        if(bad)
        {
            puts("-1");
            continue;
        }
        for(size_t up = 0; up < n && !bad; ++up)
            for(size_t left = 0; left < n; ++left)
            {
                size_t counter = 0;
                right = n2-1-left, down = n2-1-up;
				if(v[up][right] == v[0][0])
				{
					moves.push_back(Move('-', right+1));
                    moves.push_back(Move('+', up+1));
                    moves.push_back(Move('-', right+1));
                    moves.push_back(Move('+', up+1));
					tmp = v[up][left];
					v[up][left] = v[up][right];
					v[up][right] = v[down][right];
					v[down][right] = tmp;
				}
				else
					while(v[up][left] != v[0][0])
					{
						moves.push_back(Move('-', left+1));
						moves.push_back(Move('+', down+1));
						moves.push_back(Move('-', left+1));
						moves.push_back(Move('+', down+1));
						tmp = v[up][left];
						v[up][left] = v[down][right];
						v[down][right] = v[down][left];
						v[down][left] = tmp;
						++counter;
						if(counter > 3)
						{
							bad = true;
							break;
						}
					}
                if(bad)
                    break;
                counter = 0;
                while(v[up][right] != v[0][n2-1])
                {
                    moves.push_back(Move('-', right+1));
                    moves.push_back(Move('+', down+1));
                    moves.push_back(Move('-', right+1));
                    moves.push_back(Move('+', down+1));
                    tmp = v[up][right];
                    v[up][right] = v[down][left];
                    v[down][left] = v[down][right];
                    v[down][right] = tmp;
                    ++counter;
                    if(counter > 3)
                    {
                        bad = true;
                        break;
                    }
                }
				if(bad)
					break;
				if(v[down][left] == v[n2 - 1][0] && v[down][right] == v[n2 - 1][n2 - 1])
					continue;
                if(m.size() == 4 || v[down][left] != v[n2 - 1][n2 - 1] || v[down][right] != v[n2 - 1][0])
				{
					bad = true;
                    break;
				}
				if(v[up][left] == v[up][right])
				{
					moves.push_back(Move('-', right+1));
                    moves.push_back(Move('+', up+1));
                    moves.push_back(Move('-', right+1));
                    moves.push_back(Move('+', up+1));
					moves.push_back(Move('+', down+1));
					moves.push_back(Move('-', right+1));
                    moves.push_back(Move('+', down+1));
                    moves.push_back(Move('-', right+1));
				}
				else if(v[up][left] == v[down][left])
				{
					moves.push_back(Move('+', down+1));
					moves.push_back(Move('-', left+1));
                    moves.push_back(Move('+', down+1));
                    moves.push_back(Move('-', left+1));
				}
				else if(v[up][right] == v[down][right])
				{
					moves.push_back(Move('+', down+1));
					moves.push_back(Move('-', right+1));
                    moves.push_back(Move('+', down+1));
                    moves.push_back(Move('-', right+1));
				}
				else if(v[up][left] == v[down][right])
				{
					moves.push_back(Move('-', left+1));
                    moves.push_back(Move('+', down+1));
                    moves.push_back(Move('-', left+1));
					moves.push_back(Move('+', down+1));
				}
				else
				{
					moves.push_back(Move('-', right+1));
                    moves.push_back(Move('+', down+1));
                    moves.push_back(Move('-', right+1));
					moves.push_back(Move('+', down+1));
				}
            }
        if(bad)
        {
            puts("-1");
            continue;
        }
        printf("%u\n", moves.size());
        for(size_t i = 0; i < moves.size(); ++i)
            printf("%c%u\n", moves[i].dir, moves[i].num);
    }
    return 0;
}
